if select(3, UnitClass("player")) ~= 9 then return end -- Only load when playing a warlock
Whipped = LibStub("AceAddon-3.0"):NewAddon("Whipped", "AceConsole-3.0", "AceEvent-3.0")
local Whipped = _G.Whipped

-- DEBUG -- Just comment everything with this attached when done
local WHIPPED_CHAT_FONT = "Interface\\AddOns\\Whipped\\Fonts\\monofonto.ttf"
ChatFrame3:SetFont(WHIPPED_CHAT_FONT, select(2, ChatFrame3:GetFont()))

--Setup
Whipped.anchors = {"LEFT","RIGHT","TOP","BOTTOM"}
local TimeSinceLastUpdate = 0
local Whipped_UpdateInterval = .05 -- How often the OnUpdate code will run (in seconds)
local mfloor, sformat = math.floor, string.format -- DEBUG: sformat
local ScreenWidth, ScreenHeight, EffectiveScale = mfloor(GetScreenWidth()+.5), mfloor(GetScreenHeight()+.5), UIParent:GetEffectiveScale()
local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local Demons
Whipped.Demons = {
	ActiveDemons =
		function()
			return Demons.BaseDemon.Alive + Demons.Imps.Alive() + Demons.Dreadstalkers.Alive + Demons.CooldownDemon.Alive + Demons.GrimoireDemon.Alive + Demons.Darkglare.Alive
		end,
	BaseDemon = {
		Alive = 0,
		Type = 0,
		GUID = 0,
		DE = 1,
		Health =
			function()
				if Whipped.Demons.BaseDemon.Type == 157757 then -- Doomguard has less hp than the others
					return UnitHealthMax("player") * .4 * Demons.BaseDemon.DE * Demons.BaseDemon.Alive
				else
					return UnitHealthMax("player") * .5 * Demons.BaseDemon.DE * Demons.BaseDemon.Alive
				end
			end,
		Name = "NoName"
	},
	Imps = {
		Alive =
			function()
				local Imps,c = Whipped.Demons.Imps, 0
				for i=1,19 do
					c = c + Imps.HoG.Wave[i].IPW
				end
				c = c + Imps.Dreadstalkers.IPW
				for k,v in pairs(Imps.Doom.Wave) do
					c = c + v.IPW
				end
				return c
			end,
		Health = -- Get the combined hp of all your active imps
			function()
				local c, BaseImpHp = 0, UnitHealthMax("player") * 3 / 20
				for i=1,Whipped.ImpFrameListSize do
					c = c + BaseImpHp * Demons.Imps.HoG.Wave[i].DE * Demons.Imps.HoG.Wave[i].IPW
				end
					c = c + BaseImpHp * Demons.Imps.Dreadstalkers.DE * Demons.Imps.Dreadstalkers.IPW
				for k,v in pairs(Demons.Imps.Doom.Wave) do
					c = c + BaseImpHp * v.DE * v.IPW
				end
				return c
			end,
		HoG = {
			Batch = true,
			IICB = 0,
			Wave = {
				[1] = {
					Summoned = false, -- Used for nothing more than skipping entries in a loop in OnUpdate
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[2] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[3] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[4] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[5] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[6] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[7] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[8] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[9] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[10] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[11] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[12] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[13] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[14] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[15] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[16] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[17] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[18] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[19] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				}
			}
		},
		Dreadstalkers = {
			Batch = true,
			DE = 1,
			IICB = 0,
			IPW = 0, -- Imps in current batch
			--TTL: Timer is handled in Whipped_Dreadstalkers
			Dead = 0,
			GUID1 = 0,
			GUID2 = 0
		},
		Doom = {
			Batch = true,
			DE = 1,
			IICB = 0, -- Imps in current batch
			CurrentWave = 0,
			Wave = {} -- TTL, IPW, Dead, WaveNum, GUID
		}
	},
	Dreadstalkers = {
		Summoned = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Dead = 0,
		Health = -- Get the combined hp of your active dreadstalkers
			function()
				return UnitHealthMax("player") * .4 * Demons.Dreadstalkers.DE * Demons.Dreadstalkers.Alive
			end,
		GUID1 = 0,
		GUID2 = 0
	},
	CooldownDemon = {
		Summoned = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Name = "NoName",
		Health =
			function()
				return UnitHealthMax("player") * .4 * Demons.CooldownDemon.DE * Demons.CooldownDemon.Alive
			end,
		GUID = 0
	},
	GrimoireDemon = {
		Summoned = false,
		Talented = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Name = "NoName",
		Health =
			function()
				return UnitHealthMax("player") * .5 * Demons.GrimoireDemon.DE * Demons.GrimoireDemon.Alive
			end,
		GUID = 0
	},
	Darkglare = {
		Summoned = false,
		Talented = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Health =
			function()
				return UnitHealthMax("player") * .4 * Demons.Darkglare.DE * Demons.Darkglare.Alive
			end,
		GUID = 0,
	}
}
Demons = Whipped.Demons
local DE, UpdateFonts, DE_DamageIncrease = 0, -1, 1.5 -- Demonic Empowerment
local UNIT_PET_UPDATE = true -- Make sure the event only fires one bloody time each time your pet spawns or goes away

-- Frames
Whipped.MasterFrame = CreateFrame("FRAME",nil) -- The frame all other stuff should stick to
local Frame_Artifact_Icon = CreateFrame("Frame", nil, Whipped.MasterFrame)
local Frame_Demonbolt_Icon = CreateFrame("Frame", nil, Whipped.MasterFrame)
local Frame_MainDemon_Icon = CreateFrame("Frame", nil, Whipped.MasterFrame)
local FontString_Artifact = Frame_Artifact_Icon:CreateFontString()
local FontString_Demonbolt = Frame_Demonbolt_Icon:CreateFontString()

--DB and Options
local defaults = {
	global = {
		Show = true,
		Locked = false,
		ShowOOC = false, -- Out of Combat
		X = 400,
		Y = 400,
		PaddingX = 2,
		PaddingY = 2,
		Anchor = 1,
		Icons = {
			Size = 48
		},
		SoulShards = {
			Width = 10,
			Height = 40,
			Padding = 2,
			Show = true
		},
		Imps = {
			Thickness = 20,
			Padding = 2,
			Show = true
		},
		Dreadstalkers = {
			Thickness = 20,
			Padding = 2,
			Show = true
		},
		Cooldown = {
			Thickness = 20,
			Padding = 2,
			Show = true
		},
		Grimoire = {
			Thickness = 20,
			Padding = 2,
			Show = true
		},
		Darkglare = {
			Thickness = 20,
			Padding = 2,
			Show = true
		}
	}
}

function Whipped:SetupOptions()
	MasterFrame = {
		name = 'Main Options',
		type = 'group',
		args = {
			X = {
					name = 'X',
					order = 1,
					type = 'range',
					min = 0,
					max = ScreenWidth,
					step = .1,
					set = function(info, input) self.db.global.X = input; Whipped:UpdateMasterFrame() end,
					get = function(info) return self.db.global.X end
			},
			Y = {
				name = 'Y',
				order = 2,
				type = 'range',
				min = 0,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Y = input; Whipped:UpdateMasterFrame() end,
				get = function(info) return self.db.global.Y end
			},
			PaddingX = {
				name = 'Padding Horizontal',
				order = 4,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.PaddingX = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.PaddingX end
			},
			PaddingY = {
				name = 'Padding Vertical',
				order = 5,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.PaddingY = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.PaddingY end
			},
			Anchor = {
				name = 'Anchor',
				order = 6,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Anchor = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.Anchor end
			},
			Locked = {
				name = 'Locked',
				type = 'toggle',
				order = 7,
				set =
					function(info, input)
						self.db.global.Locked = input;
						Whipped.MasterFrame:EnableMouse(not input);
						Whipped.MasterFrame:SetMovable(not input);
					end,
				get =
					function(info)
						return self.db.global.Locked
					end
			},
			Show = {
				name = 'Show',
				type = 'toggle',
				order = 8,
				set =
					function(info, input)
						self.db.global.Show = input;
						if input == true then
							Whipped.MasterFrame:Show()
						else
							Whipped.MasterFrame:Hide()
						end
					end,
				get =
					function(info)
						return self.db.global.Show
					end
			},
			ShowOOC = {
				name = 'Show out of combat',
				type = 'toggle',
				order = 9,
				set =
					function(info, input)
						self.db.global.ShowOOC = input;
						if input and self.db.global.Show and GetSpecialization() == 2 then
							Whipped.MasterFrame:Show()
						elseif not InCombatLockdown() then
							Whipped.MasterFrame:Hide()
						end
					end,
				get =
					function(info)
						return self.db.global.ShowOOC
					end
			},
			Icons = {
				name = 'Icon Size',
				order = 3,
				type = 'range',
				min = 1,
				max = 100,
				step = .1,
				set = function(info, input) self.db.global.Icons.Size = input; Whipped:UpdateMasterFrame() end,
				get = function(info) return self.db.global.Icons.Size end
			}
		}
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Whipped", MasterFrame) -- AppName, Options, SlashCMD
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Whipped") -- AppName, Name(Defaults to AppName), Parent

	Whipped:SoulShards_SetupOptions()
	Whipped:Imps_SetupOptions()
	Whipped:Dreadstalkers_SetupOptions()
	Whipped:Cooldown_SetupOptions()
	Whipped:Grimoire_SetupOptions()
	Whipped:Darkglare_SetupOptions()
end

function Whipped:AddCategory(name, option)
	if not self.options then
		self.options = {
			name = "Whipped",
			type = 'group',
			args = {}
		}
		self.options.frames = {}
	end
	
	self.options.args[name] = option --Dynamically adds a new arg name to fill in with our options
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Whipped/".. name, self.options.args[name], "Whipped/"..name)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Whipped/" .. name, option.name, "Whipped")
end

Whipped:RegisterChatCommand("Whipped",
	function()
		InterfaceOptionsFrame_OpenToCategory("Whipped")
		InterfaceOptionsFrame_OpenToCategory("Whipped")
	end)
-- Scripts and Events
function Whipped:COMBAT_LOG_EVENT_UNFILTERED(_, ...)
	local event = select(2, ...)
	if strfind(event,"_DAMAGE") then
		Whipped:Imps_CLE(...)
	elseif event == "SPELL_CAST_SUCCESS" then
		if select(12,...) == 193396 and bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			ActionButton_ShowOverlayGlow(Frame_MainDemon_Icon)
			DE = GetTime() + 12
			Demons.BaseDemon.DE = DE_DamageIncrease
			Demons.Dreadstalkers.DE = DE_DamageIncrease
			Demons.CooldownDemon.DE = DE_DamageIncrease
			Demons.GrimoireDemon.DE = DE_DamageIncrease
			Demons.Darkglare.DE = DE_DamageIncrease
			for i=1,Whipped.ImpFrameListSize do
				Demons.Imps.HoG.Wave[i].DE = DE_DamageIncrease
			end
			Demons.Imps.Dreadstalkers.DE = DE_DamageIncrease
			for k,v in pairs(Demons.Imps.Doom.Wave) do
				v.DE = DE_DamageIncrease
			end
			FontString_Artifact:SetText(Whipped:ArtifactDamage())
			Whipped:Imps_CLE(...)
			Whipped:Dreadstalkers_CLE(...)
			Whipped:Cooldown_CLE(...)
			Whipped:Grimoire_CLE(...)
			Whipped:Darkglare_CLE(...)
		end
	elseif event == "SPELL_AURA_REMOVED" then
		if select(12,...) == 193396 and bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			ActionButton_HideOverlayGlow(Frame_MainDemon_Icon)
			Whipped:Cooldown_CLE(...)
			Whipped:Grimoire_CLE(...)
		end
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_SUMMON" then
		if bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			local SpellID = select(12, ...)
			if SpellID == 30146 or SpellID == 157757 or SpellID == 157898 then -- Felguard, Doomguard, Infernal; Wrathguard still needs adding, ignoring all lesser base pets
				UNIT_PET_UPDATE = false
				Demons.BaseDemon.Alive = 1
				Demons.BaseDemon.DE = 1
				Demons.BaseDemon.Type = SpellID
				Demons.BaseDemon.GUID = select(8, ...)
				Demons.BaseDemon.Name = select(9, ...)
				-- DEBUG
				-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-15s".."|".."%-20s".."| "..Demons.ActiveDemons(),
					-- event,
					-- "'"..select(9,...).."'",
					-- "'"..select(13,...).."'"))
				--
			end
		end
		Whipped:Dreadstalkers_CLE(...)
		Whipped:Imps_CLE(...)
		Whipped:Cooldown_CLE(...)
		Whipped:Grimoire_CLE(...)
		Whipped:Darkglare_CLE(...)
	elseif event == "UNIT_DIED" then
		local DemonGUID = select(8,...)
		if DemonGUID == Demons.BaseDemon.GUID then -- Felguard, Doomguard, Infernal; Wrathguard still needs adding
			UNIT_PET_UPDATE = nil
			Demons.BaseDemon.Alive = 0
			Demons.BaseDemon.GUID = 0
			-- DEBUG
			-- local SummonedDemon
			-- if Whipped.Demons.BaseDemon.Type == 30146 then
				-- SummonedDemon = "Summon Felguard"
			-- elseif Whipped.Demons.BaseDemon.Type == 157757 then
				-- SummonedDemon = "Summon Doomguard"
			-- else
				-- SummonedDemon = "Summon Infernal"
			-- end
			-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-15s".."|".."%-20s".."| "..Demons.ActiveDemons(),
				-- event,
				-- "'"..select(9,...).."'",
				-- "'"..SummonedDemon.."'"))
			------
		end
		Whipped:Dreadstalkers_CLE(...)
		--Whipped:Imps_CLE(...) -- Little guys don't have a UNIT_DIED event
		Whipped:Cooldown_CLE(...)
		Whipped:Grimoire_CLE(...)
		Whipped:Darkglare_CLE(...)
	elseif event == "SPELL_AURA_APPLIED" then
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_AURA_REMOVED" then
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_INSTAKILL" then
		Whipped:Imps_CLE(...)
	end
end

-- local Demonbolt = false -- DEBUG
function Whipped:PLAYER_TALENT_UPDATE()
	if GetSpecialization() == 2 then
		local id,_,_,b = GetTalentInfo(7,2,1)
		if id == 22479 and b then
			Demonbolt = true --DEBUG
			Frame_Demonbolt_Icon:Show()
		else
			Demonbolt = false --DEBUG
			Frame_Demonbolt_Icon:Hide()
		end
		Whipped:Grimoire_UpdateTalents()
		Whipped:Darkglare_UpdateTalents()
		
		Whipped:UpdateAllFrames()
		
		-- DEBUG
		-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-36s".."| "..tostring(Demonbolt),
			-- "TALENT_UPDATE",
			-- "'Demonbolt'"))
		------
	end
end

function Whipped:ACTIVE_TALENT_GROUP_CHANGED()
	if GetSpecialization() == 2 then
		if self.db.global.ShowOOC == false or self.db.global.Show == false then
			Whipped.MasterFrame:Hide()
		else
			Whipped.MasterFrame:Show()
		end
	else
		Whipped.MasterFrame:Hide()
	end
	-- DEBUG
	-- local _,n = GetSpecializationInfo(GetSpecialization())
	-- n = n or "error"
	-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-15s",
		-- "SPEC_UPDATE",
		-- "'"..n.."'"))
	------
end

function Whipped:UNIT_PET(_, unitID)
	if unitID == "player" and UNIT_PET_UPDATE ~= nil then -- nil is when the pet died
		if UNIT_PET_UPDATE and (not UnitIsDead("pet") or UnitExists("pet")) then -- Pet is alive
			UNIT_PET_UPDATE = false
			Demons.BaseDemon.Alive = 1
			Demons.BaseDemon.GUID = UnitGUID("pet")
			local demon = UnitCreatureFamily("pet")
			if demon == "Felguard" then
				Demons.BaseDemon.Type = 30146
			--elseif demon == "Wrathguard" == 
			--	Demons.BaseDemon.Type = 
			elseif demon == "Doomguard" then
				Demons.BaseDemon.Type = 157757
			elseif demon == "Infernal" then
				Demons.BaseDemon.Type = 157898
			end
			-- DEBUG
			-- local SummonedDemon
			-- if Whipped.Demons.BaseDemon.Type == 30146 then
				-- SummonedDemon = "Summon Felguard"
			-- elseif Whipped.Demons.BaseDemon.Type == 157757 then
				-- SummonedDemon = "Summon Doomguard"
			-- else
				-- SummonedDemon = "Summon Infernal"
			-- end
			-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-15s".."|".."%-20s".."| "..Demons.ActiveDemons(),
				-- "UNIT_PET",
				-- " Spawn",
				-- "'"..SummonedDemon.."'"))
			------
		elseif not UNIT_PET_UPDATE and (UnitIsDead("pet") or not UnitExists("pet")) then -- Pet is dismissed or pulls a Houdini
			UNIT_PET_UPDATE = true
			Demons.BaseDemon.Alive = 0
			Demons.BaseDemon.GUID = 0
			-- DEBUG
			-- local SummonedDemon
			-- if Whipped.Demons.BaseDemon.Type == 30146 then
				-- SummonedDemon = "Summon Felguard"
			-- elseif Whipped.Demons.BaseDemon.Type == 157757 then
				-- SummonedDemon = "Summon Doomguard"
			-- else
				-- SummonedDemon = "Summon Infernal"
			-- end
			-- Whipped:Print(ChatFrame3, sformat("%-15s".."|".."%-15s".."|".."%-20s".."| "..Demons.ActiveDemons(),
				-- "UNIT_PET",
				-- " Despawn",
				-- "'"..SummonedDemon.."'"))
			------
		end
	end
end

function Whipped:UNIT_MAXHEALTH(_, unitID)
	if unitID == "player" then
		FontString_Artifact:SetText(Whipped:ArtifactDamage())
	end
end

function Whipped:PLAYER_REGEN_DISABLED()
	if self.db.global.Show and GetSpecialization() == 2 then
		Whipped.MasterFrame:Show()
	end
end

function Whipped:PLAYER_REGEN_ENABLED()
	if self.db.global.ShowOOC == false or self.db.global.Show == false then
		Whipped.MasterFrame:Hide()
	end
end

function Whipped:LOADING_SCREEN_DISABLED()
	if self.db.global.Show == true and GetSpecialization() == 2 then
		if self.db.global.ShowOOC then
			self.MasterFrame:Show()
		elseif not InCombatLockdown() then
			self.MasterFrame:Hide()
		end
	else
		Whipped.MasterFrame:Hide()
	end
end

Whipped:RegisterEvent("PLAYER_ENTERING_WORLD",
	function()
		Whipped:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		Whipped:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Whipped:RegisterEvent("PLAYER_TALENT_UPDATE")
		Whipped:RegisterEvent("UNIT_PET")
		Whipped:RegisterEvent("UNIT_MAXHEALTH")
		Whipped:RegisterEvent("PLAYER_REGEN_DISABLED")
		Whipped:RegisterEvent("PLAYER_REGEN_ENABLED")
		Whipped:RegisterEvent("LOADING_SCREEN_DISABLED")
		Whipped:ACTIVE_TALENT_GROUP_CHANGED()
	end)
	
--Functions
function Whipped:OnInitialize()
	self:SetupOptions() -- Create all the options menus
	self.db = LibStub("AceDB-3.0"):New("WhippedDB", defaults, true)

	-- MasterFrame
	self.MasterFrame.texture = self.MasterFrame:CreateTexture(nil, "BACKGROUND")
	self.MasterFrame.texture:SetAllPoints(true)
	self.MasterFrame.texture:SetTexture(1,1,1,0)
	self.MasterFrame.texture:SetVertexColor(1,0,0,.5)
	self.MasterFrame:SetMovable(not self.db.global.Locked)
	self.MasterFrame:EnableMouse(not self.db.global.Locked)
	self.MasterFrame:RegisterForDrag("LeftButton")
	self.MasterFrame:SetScript("OnDragStart", self.MasterFrame.StartMoving)
	self.MasterFrame:SetScript("OnDragStop",
		function()
			Whipped.MasterFrame:StopMovingOrSizing()
			local x = mfloor(Whipped.MasterFrame:GetLeft() / EffectiveScale + .5)
			local y = mfloor(Whipped.MasterFrame:GetBottom() / EffectiveScale + .5)
			self.db.global.X = x
			self.db.global.Y = y
		end)
	self.MasterFrame:SetScript("OnUpdate", Whipped_OnUpdate)
	
	-- Artifact Icon
	Frame_Artifact_Icon.texture = Frame_Artifact_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Artifact_Icon.texture:SetTexture("Interface\\Icons\\Inv_offhand_1h_artifactskulloferedar_d_01")
	Frame_Artifact_Icon.texture:SetAllPoints(true)
	
	-- Demonbolt Icon
	Frame_Demonbolt_Icon.texture = Frame_Demonbolt_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Demonbolt_Icon.texture:SetTexture("Interface\\Icons\\spell_warlock_demonbolt")
	Frame_Demonbolt_Icon.texture:SetAllPoints(true)
	
	-- Demon Icon
	Frame_MainDemon_Icon.texture = Frame_MainDemon_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_MainDemon_Icon.texture:SetTexture("Interface\\Icons\\spell_shadow_summonfelguard")
	Frame_MainDemon_Icon.texture:SetAllPoints(true)
	
	-- Fontstring Artifact
	FontString_Artifact:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Size / 3)
	FontString_Artifact:SetTextColor(1,1,1,1)
	FontString_Artifact:SetText(self:ArtifactDamage())
	
	-- Fontstring Demonbolt
	FontString_Demonbolt:SetPoint("CENTER")
	FontString_Demonbolt:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Size / 3)
	FontString_Demonbolt:SetTextColor(1,1,1,1)
	FontString_Demonbolt:SetText(Demons.ActiveDemons())
	
	self:PLAYER_TALENT_UPDATE()
	
	self:SoulShards_OnLoad()
	self:Dreadstalkers_OnLoad()
	self:Imps_OnLoad()
	self:Cooldown_OnLoad()
	self:Grimoire_OnLoad()
	self:Darkglare_OnLoad()

	self:UpdateAllFrames()
end

function Whipped:OnEnable() -- Called when the addon is enabled
end

function Whipped:OnDisable() -- Called when the addon is disabled
end

function Whipped_OnUpdate(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;
	
	while (TimeSinceLastUpdate > Whipped_UpdateInterval) do
		if UpdateFonts ~= Demons.ActiveDemons() then -- Only run when your amount of demons changes
			FontString_Artifact:SetText(Whipped:ArtifactDamage())
			FontString_Demonbolt:SetText(Demons.ActiveDemons())
			UpdateFonts = Demons.ActiveDemons()
		end
	
		if DE > 0 then
			if DE - GetTime() < 0 then
				DE = 0
				Demons.BaseDemon.DE = 1
				Demons.Dreadstalkers.DE = 1
				Demons.CooldownDemon.DE = 1
				Demons.GrimoireDemon.DE = 1
				Demons.Darkglare.DE = 1
				for i=1,Whipped.ImpFrameListSize do
					Demons.Imps.HoG.Wave[i].DE = 1
				end
				Demons.Imps.Dreadstalkers.DE = 1
				for k,v in pairs(Demons.Imps.Doom.Wave) do
					v.DE = 1
				end
				FontString_Artifact:SetText(Whipped:ArtifactDamage())
			end
		end
		
		Whipped:SoulShards_OnUpdate()
		Whipped:Dreadstalkers_OnUpdate()
		Whipped:Imps_OnUpdate()
		Whipped:Cooldown_OnUpdate()
		Whipped:Grimoire_OnUpdate()
		Whipped:Darkglare_OnUpdate()
		TimeSinceLastUpdate = 0
	end
end

function Whipped:UpdateMasterFrame()
	-- Updates MasterFrame + Icons
	local MasterFrame = Whipped.db.global
	local anchorID = Whipped.db.global.Anchor
	local anchor, Oanchor = Whipped.anchors[anchorID], Whipped:OppositeAnchor(anchorID)
	local SoulShards = MasterFrame.SoulShards
	local Imps = MasterFrame.Imps
	local Dreadstalkers = MasterFrame.Dreadstalkers
	local Cooldown = MasterFrame.Cooldown
	local Grimoire = MasterFrame.Grimoire
	local Darkglare = MasterFrame.Darkglare

	local add = 0
	if SoulShards.Show then
		if anchorID == 1 or anchorID == 2 then
			add = add + SoulShards.Height + SoulShards.Padding
		else
			add = add + SoulShards.Width + SoulShards.Padding
		end
	end
	if Imps.Show then
		add = add + Imps.Thickness + Imps.Padding * 2
	end
	if Dreadstalkers.Show then
		add = add + Dreadstalkers.Thickness + Dreadstalkers.Padding * 2
	end
	if Cooldown.Show then
		add = add + Cooldown.Thickness + Cooldown.Padding * 2
	end
	if Demons.GrimoireDemon.Talented and Grimoire.Show then
		add = add + Grimoire.Thickness + Grimoire.Padding * 2
	end
	if Demons.Darkglare.Talented and Darkglare.Show then
		add = add + Darkglare.Thickness + Darkglare.Padding * 2
	end
	
	if anchorID == 1 or anchorID == 2 then -- Left or Right
		Whipped.MasterFrame:SetWidth((SoulShards.Width * 5 + SoulShards.Padding * 4 + MasterFrame.PaddingX * 2) * EffectiveScale)
		Whipped.MasterFrame:SetHeight((MasterFrame.PaddingY * 2 + add) * EffectiveScale)
	else -- Top or Bottom
		Whipped.MasterFrame:SetWidth((MasterFrame.PaddingX * 2 + add) * EffectiveScale)
		Whipped.MasterFrame:SetHeight((SoulShards.Height * 5 + SoulShards.Padding * 4 + MasterFrame.PaddingY * 2) * EffectiveScale)
	end
	Frame_Artifact_Icon:SetWidth(self.db.global.Icons.Size * EffectiveScale)
	Frame_Artifact_Icon:SetHeight(self.db.global.Icons.Size * EffectiveScale)
	Frame_Demonbolt_Icon:SetWidth(self.db.global.Icons.Size * EffectiveScale)
	Frame_Demonbolt_Icon:SetHeight(self.db.global.Icons.Size * EffectiveScale)
	FontString_Artifact:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Size / 3)
	FontString_Demonbolt:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Size / 3)
	
	Frame_Artifact_Icon:ClearAllPoints()
	FontString_Artifact:ClearAllPoints()
	Frame_Demonbolt_Icon:ClearAllPoints()
	Frame_MainDemon_Icon:ClearAllPoints()
	
	local offset = 0
	if Demonbolt then
		offset = self.db.global.Icons.Size / 2 * EffectiveScale
	end
	
	if anchorID == 1 then
		Frame_Artifact_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, 0, offset)
		FontString_Artifact:SetPoint("RIGHT",Frame_Artifact_Icon, "LEFT", -2 * EffectiveScale, 0)
		Frame_Demonbolt_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, 0, -self.db.global.Icons.Size / 2 * EffectiveScale)
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height * EffectiveScale)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height * EffectiveScale)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Whipped.MasterFrame, "TOPRIGHT", 0, -MasterFrame.PaddingY)
	elseif anchorID == 2 then
		Frame_Artifact_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, 0, offset)
		FontString_Artifact:SetPoint(Oanchor,Frame_Artifact_Icon, anchor, 2 * EffectiveScale, 0)
		Frame_Demonbolt_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, 0, -self.db.global.Icons.Size / 2 * EffectiveScale)
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height * EffectiveScale)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height * EffectiveScale)
		Frame_MainDemon_Icon:SetPoint("TOPRIGHT", Whipped.MasterFrame, "TOPLEFT", 0, -MasterFrame.PaddingY)
	elseif anchorID == 3 then
		Frame_Artifact_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, -offset, 0)
		FontString_Artifact:SetPoint("RIGHT",Frame_Artifact_Icon, "LEFT", -2 * EffectiveScale, 0)
		Frame_Demonbolt_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, self.db.global.Icons.Size / 2 * EffectiveScale, 0)
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width * EffectiveScale)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width * EffectiveScale)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Whipped.MasterFrame, "BOTTOMLEFT", MasterFrame.PaddingX, 0)
	elseif anchorID == 4 then
		Frame_Artifact_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, -offset, 0)
		FontString_Artifact:SetPoint("RIGHT",Frame_Artifact_Icon, "LEFT", -2 * EffectiveScale, 0)
		Frame_Demonbolt_Icon:SetPoint(Oanchor, Whipped.MasterFrame, anchor, self.db.global.Icons.Size / 2 * EffectiveScale, 0)
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width * EffectiveScale)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width * EffectiveScale)
		Frame_MainDemon_Icon:SetPoint("BOTTOMLEFT", Whipped.MasterFrame, "TOPLEFT", MasterFrame.PaddingX, 0)
	end
	
	if SoulShards.Show then
		Frame_MainDemon_Icon:Show()
	else
		Frame_MainDemon_Icon:Hide()
	end
	
	Whipped.MasterFrame:ClearAllPoints()
	Whipped.MasterFrame:SetPoint("BOTTOMLEFT", MasterFrame.X * EffectiveScale, MasterFrame.Y * EffectiveScale)
end

function Whipped:UpdateAllFrames()
	Whipped:UpdateMasterFrame()
	Whipped:SoulShards_UpdateFrames()
	Whipped:Dreadstalkers_UpdateFrames()
	Whipped:Imps_UpdateFrames()
	Whipped:Cooldown_UpdateFrames()
	Whipped:Grimoire_UpdateFrames()
	Whipped:Darkglare_UpdateFrames()
end

function Whipped:OppositeAnchor(id)
	if id % 2 == 0 then
		return Whipped.anchors[id-1]
	else
		return Whipped.anchors[id+1]
	end
end

function Whipped:ArtifactDamage()
	local d,dmg=Whipped.Demons,0
	b,c,g,e,d,i=d.BaseDemon,d.CooldownDemon,d.GrimoireDemon,d.Darkglare,d.Dreadstalkers,d.Imps
	return mfloor((b.Health()+c.Health()+g.Health()+e.Health()+d.Health()+i.Health())*.06)
end

-- DEBUG
-- function Whipped:DEBUG(arg1, arg2, arg3, arg4)
	-- -- #1 Table to parse
	-- -- #2 How deep to go(nil if endless)
	-- -- #3 type to find(nil if none, "all" if any)
	-- -- #4 Used by recursion, do not use manually
	-- local function Spaces(s)
		-- local S = ""
		-- for c = 1, s do
			-- S = S.."|  "
		-- end
		-- return S
	-- end
	-- if type(arg1) ~= 'table' then Whipped:Print("Argument is not of type 'table'. Is type '"..type(arg1).."'"); return end
	-- if arg4 == nil then print("root") end
	-- local arg4 = arg4 or 1
	-- if arg4 > (arg2 or arg4 + 1) then return end -- arg4 + 1 is to parse the whole tree, no matter how deep
	
	-- for k,v in pairs(arg1) do
		-- if type(v) == arg3 or type(v) == 'table' or 'all' == arg3 then
			-- if 'table' == type(v) then
				-- print(Spaces(arg4)..tostring(k).." - "..type(v))
				-- self:DEBUG(v, arg2, arg3, arg4 + 1)
			-- else
				-- print(Spaces(arg4)..tostring(k).." - "..type(v))
			-- end
		-- end
	-- end
-- end